﻿using Syncfusion.Windows.Shared;
using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ComboBoxTreeView
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
          
           
        }

        private void treeView_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            ComboBoxTreeView.IsDropDownOpen = false;
        }

     
    }

    public class ViewModel
    {
        public ViewModel()
        {
            var items13 = new List<Model>{
                                new Model("Item 1.3.1", null) {IsSelected=true },
                                new Model("Item 1.3.2", null)};

            var items1 = new List<Model>{
                                new Model("Item 1.1", null),
                                new Model("Item 1.2", null),
                                new Model("Item 1.3", items13)};
            var items2 = new List<Model>{
                                new Model("Item 2.1", null),
                                new Model("Item 2.2", null)};

            var outerItems = new List<Model>{
                                new Model("Item 1", items1) , 
                                new Model("Item 2", items2)};

            this.Items = outerItems;
           
        }

        public List<Model> Items { get; set; }

    
    }

    public class Model  
    {
        public Model(string title, List<Model> children, Model parent = null)
        {
            this.Title = title;
            this.Parent = parent;
            this.Children = children;
            this.IsSelected = false;
            if (this.Children != null)
            {
                this.Children.ForEach(ch => ch.Parent = this);
            }
        }

        public string Title { get; set; }

        public Model Parent { get; set; }

     
        public  bool IsSelected { get; set; }

        public List<Model> Children { get; set; }

    }
    public class BoolToValue : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
    public class ViewModelToValue : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value != null)
            {
                Model vm = value as Model;
                return vm.Title;
            }
            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
